// TaskDialog.cpp: Implementierungsdatei
//

#include "stdafx.h"
#include "MP3reFormater.h"
#include "TaskDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


CString ExtractFileExtension(CString file)
{
	int pointPos = file.ReverseFind('.');

	if (pointPos != -1)
	{
		return file.Mid(pointPos+1);
	}

	return "";
}

/////////////////////////////////////////////////////////////////////////////
// Dialogfeld CTaskDialog 


CTaskDialog::CTaskDialog(CWnd* pParent /*=NULL*/)
	: CDialog(CTaskDialog::IDD, pParent)
{
	parent = NULL;
	workIsDone = false;

	//{{AFX_DATA_INIT(CTaskDialog)
		// HINWEIS: Der Klassen-Assistent fgt hier Elementinitialisierung ein
	//}}AFX_DATA_INIT
}


void CTaskDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTaskDialog)
		// HINWEIS: Der Klassen-Assistent fgt hier DDX- und DDV-Aufrufe ein
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CTaskDialog, CDialog)
	//{{AFX_MSG_MAP(CTaskDialog)
	ON_WM_SHOWWINDOW()
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Behandlungsroutinen fr Nachrichten CTaskDialog 

void CTaskDialog::OnShowWindow(BOOL bShow, UINT nStatus) 
{
	CDialog::OnShowWindow(bShow, nStatus);
	
	DoWork();
}

void CTaskDialog::DoWork()
{
	TRACE0("Beginning Work..\n");

	CArray<CString,CString&>& dirs = parent->GetDirs();

	for (int i = 0; i < dirs.GetSize(); i++)
	{
		TRACE1("Processing %s\n",dirs[i]);
		ProcessFilesFromFolder(dirs[i]);
	}

	TRACE0("Ending Work..\n");
	workIsDone = true;
}

void CTaskDialog::SetParentDlg(CMP3reFormaterDlg *window)
{
	parent = window;
}

void CTaskDialog::ProcessFilesFromFolder(CString folder)
{
	//Test ob's stimmt
	CFileStatus status;
	CFile::GetStatus(folder,status);
	
	if (!((status.m_attribute & directory) == directory))
	{
		return;
	}

	CFileFind finder;
	char oldDir[512];
	GetCurrentDirectory(512,oldDir);

	SetCurrentDirectory(folder);

	bool working = finder.FindFile();

	while (working)
	{
		working = finder.FindNextFile();

		if (finder.IsDirectory() && !finder.IsDots())
		{
			if (parent->GetIncludeSubdirs())
			{
				ProcessFilesFromFolder(finder.GetFilePath()+"\\.");
			}
		}
		else
		{
			TRACE1("File found: %s\n",finder.GetFilePath());
			CString filename = finder.GetFileName();
			CString filepath = finder.GetFilePath();
			CString extension = ExtractFileExtension(filepath);
			extension.MakeLower();

								
			if (filename != "." && filename != ".." && 
			/* check for extension */	( parent->GetExtensions().Find(  
				extension ) != -1 ) )
			{
				ReformatFile(filename,filepath);
			}
			
		}
	}
	
	SetCurrentDirectory(oldDir);
}

void CTaskDialog::ReformatFile(CString filename,CString filepath)
{
	TRACE1("Reformatting %s\n",filepath);

	CString oldFilename = filename;
	CString oldFilepath = filepath;
	

	//correct spacings

	if (parent->GetCorrectSpacings())
	{
		if (filename[0] == ' ')
			filename.Delete(0,1);

		while (filename.Replace("  "," ") != 0) ;
	}

	//make words upper

	if (parent->GetMakeUpper())
	{
		if (islower(filename[0]))
			filename.SetAt(0,toupper(filename[0]));

		for (int i = 1; i < filename.GetLength(); i++)
		{
			//word separtors : ' '-(.
			if (filename[i-1] == ' ' || filename[i-1] == '(' ||
				filename[i-1] == '-')
			{
				filename.SetAt(i,toupper(filename[i]));
			}
		}
	}

	//change path
	filepath.Replace(oldFilename,filename);

	//TRACE1("New Path: %s\n,",filepath);

	try
	{
		//finally rename
		CFile::Rename(oldFilepath,filepath);
	}
	catch (CFileException* e)
	{
		CString string;

		string.Format("File %s couldn't be renamed in %s",oldFilepath,
			filepath);
		TRACE0(string);
	}
	
}

void CTaskDialog::OnTimer(UINT nIDEvent) 
{
	if (workIsDone)
		OnOK();

	CDialog::OnTimer(nIDEvent);
}

BOOL CTaskDialog::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	SetTimer(1,1000,NULL);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX-Eigenschaftenseiten sollten FALSE zurckgeben
}

